/*//
//  MainGame.m
//  SnakeMenu
//
//  Created by HANSON, PAUL  on 28/04/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "MainGameDraw.h"


@implementation MainGameDraw


//use this to init custom view
-(id)initWithCoder:(NSCoder*)decoder
{
	if (self = [super initWithCoder:decoder])
	{
		//init variables
		start = NO;
		movementHold = 0;
		currentDirection = 3;
		
		//create audio
		[self createAudio];
	}
	

	
	
	return self;
}

/*
 Change Views
*/
-(IBAction) goToGameOver
{
	
	SnakeMenuAppDelegate *snakeAppDelegate = (SnakeMenuAppDelegate*)[UIApplication sharedApplication].delegate;
	[snakeAppDelegate goToGameOver];
	
}

/*
Passes the context to the render function
Draws the text
 */
- (void)drawRect:(CGRect)rect 
{
	//grab context
	CGContextRef CG = UIGraphicsGetCurrentContext();
	
	//set fill colour to black
	CGContextSetRGBFillColor(CG, 0.0f, 0.0f, 0.0f, 1.0f);
	
	//fill rectangle with size of the view
	CGContextFillRect(CG, rect);
	
	//render map, pass context
	render(CG);
	//select font
	CGContextSetRGBFillColor(CG, 1.0f, 1.0f, 1.0f, 1.0f);
	CGContextSelectFont(CG, "Helvetica", 16.0, kCGEncodingMacRoman); //context, font, size, encoding
	
	//flip that stuff
	CGContextSetTextMatrix(CG, CGAffineTransformMakeScale(1.0, -1.0));
	
	//set drawing mode
	CGContextSetTextDrawingMode(CG, kCGTextFill);
	
	//get the score and store as an NSString
	NSString *scoreText = [NSString stringWithFormat:@"Score: %i", getScore()];
	
	//display text
	CGContextShowTextAtPoint(CG, 16.0, 32.0, [scoreText UTF8String], [scoreText length]);
}

-(void)touchesEnded:(NSSet*)touches withEvent:(UIEvent*)event
{
}

-(void)touchesMoved:(NSSet*)touches withEvent:(UIEvent*)event
{	
}

/*
 Detects the start of a touch
 */
-(void)touchesBegan:(NSSet*)touches withEvent:(UIEvent*)event
{
	//start game on first touch
	if (!start)
	{
		start = YES;
		return; //required to prevent the direction from changing and detecting a collision with the first touch. game testing pays off
	}
	
	//get the first touch from the set
	UITouch *firstTouch = [[touches allObjects] objectAtIndex:0];
	
	//get the touch from the view
	currentTouchPoint = [firstTouch locationInView:self];
	
	int travelDirection = getCurrentDirection();
	/*
	 0 - Up
	 1 - Down
	 2 - Left
	 3 - Right
	 A and Start
	 */
	
	//snake travelling vertically
	if (travelDirection == 0 || travelDirection == 1)
	{
		//right side
		if (currentTouchPoint.x > 160)
			currentDirection = 3;
		
		//left side
		else
			currentDirection = 2;
	}
	
	//snake travelling horizontally
	if (travelDirection == 2 || travelDirection == 3)
	{
		//bottom
		if (currentTouchPoint.y > 240)
			currentDirection = 1;
		
		//top
		else
			currentDirection = 0;
	}
	
}

/*
 Runs the main game loop
 */
-(void)update
{	
	if (start)
	{
		/*	only update the snake if the counter is equal to the movement speed of the snake
		no need to update the screen is the snake has not changed position	 */
		if (movementHold == getSpeed())
		{
			//update the snakes current position and get the return value
			int collision = move(currentDirection);
			//collsion with item
			if(collision == 1)
			{
				//play audio clip
				[sound playSound:@"Chomp"];
			}
		
			//collision with snake
			if(collision == 2)
			{
				//dont update the game anymore
				start = NO;
				
				//go to the game over screen
				SnakeMenuAppDelegate *snakeAppDelegate = (SnakeMenuAppDelegate*)[UIApplication sharedApplication].delegate;
				[snakeAppDelegate goToGameOver];
			}
			
			//reset movement
			movementHold = 0;
			
			//redraw
			[self setNeedsDisplay];
		}
		
		movementHold++;			
		
	}	
	
}

/*
 Sets up OpenAL
 */
-(void)createAudio
{

	//sound clip
	sound = [[audioAL alloc] init];
	
	//init OpenAL device and context
	if([sound initAudioDevice])
	{
		printf("OpenAL Device Created\n");
	}
	
	//load OpenAL audio
	if ([sound loadAudio])
	{
		printf("OpenAL Clips Loaded\n");
	}	

}

- (void)dealloc 
{	
	cleanUp();
	
	[sound cleanUpSound];
	[sound release];
	[super dealloc];
}



@end
*/