//
//  SnakeMenuAppDelegate.m
//  SnakeMenu
//
//  Created by HANSON, PAUL  on 22/04/2010.
//  Copyright __MyCompanyName__ 2010. All rights reserved.
//

#import "SnakeMenuAppDelegate.h"

@implementation SnakeMenuAppDelegate

@synthesize window;
@synthesize viewController;
@synthesize hiScoreViewController;
@synthesize gameOverViewController;
@synthesize menu;


//menu = menu
//viewController = main Game

- (void)applicationDidFinishLaunching:(UIApplication *)application 
{    
    
	
	//set up the game
	runLogic();
	//set up the music
	[self setUpMusic];
	
	//test data
	/*
	[self loadData];
	// = [NSNumber numberWithInt:yourIntValue];
	NSNumber *number = [[NSUserDefaults standardUserDefaults] objectForKey:@"testData"];
	int i = [number integerValue];
	printf("Test Data is : %i \n", i);
	*/
	
	//starting view for the game - should be menu unless testing
    [window addSubview: menu.view];
    [window makeKeyAndVisible];
}

//screen logic functions
//called from menu screen
-(void) startGame
{
	//play the music
	[musicPlayer playAVAudio];
	
	//change views
	[menu.view removeFromSuperview];
	[window addSubview:viewController.view];	
}

//called from menu screen
-(void) goToHiScore
{
	//file test
	//NSNumber *testInt = 25;
	//NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	//[defaults setObject:testInt forKey:@"testData"];
	//[defaults synchronize];
	
	//change views
	[menu.view removeFromSuperview];
	[window addSubview:hiScoreViewController.view];
}

//called from menu screen
-(void) goToGameOver
{
	//check the high score
	compareScores();
	//stop the music
	[musicPlayer pauseAVAudio];
	
	//change views
	[viewController.view removeFromSuperview];
	[window addSubview:gameOverViewController.view];
}

//called from game over screen
-(void) goToMainMenuFromGameOver
{
	//reset the game
	reset();	
	//change views
	[gameOverViewController.view removeFromSuperview];
	[window addSubview:menu.view];
}

//called from game over screen
-(void) restartGame
{
	//reset the game
	reset();
	
	//play the music
	[musicPlayer playAVAudio];
	
	//change views
	[gameOverViewController.view removeFromSuperview];
	[window addSubview:viewController.view];
}

//called from hi score screen
-(void) goToMainMenuFromHiScore
{
	//change views
	[hiScoreViewController.view removeFromSuperview];
	[window addSubview:menu.view];
}

/*
 sets up the AVAudioPlayer
 */
-(void) setUpMusic
{
	//av
	musicPlayer = [[audioAV alloc] init];
	
	//init the av audio
	[musicPlayer initAVAudio:@"MainMusic"];
	
	//set the volume
	[musicPlayer setAVVolume: 0.5f]; 
	
}

- (void)applicationWillTerminate:(UIApplication *)application
{
	[musicPlayer stopAVAudio];
	
	printf("calling termination\n");
	
	//Test data
	/*
	//saving code temp location
	//get the path of the location to save data
	//we are using documents directory for save data
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory =[paths objectAtIndex:0];
	//sort out the file name to get the file we need
	NSString *filename = @"lulz";
	NSString *saveFile = [documentsDirectory stringByAppendingPathComponent:filename];
	
	//kick ass file operations
	//use the file manager object
	NSFileManager * fileManager = [NSFileManager defaultManager];
	
	//check to see if file exists
	if ([fileManager fileExistsAtPath:saveFile])
	{
		//remove the file it
		[fileManager removeItemAtPath:filename error:nil];
	}
	
	//create a new kick ass file
	[fileManager createFileAtPath:saveFile contents:nil attributes:nil];
	
	
	//save the file
	//create the file handle
	NSFileHandle * filehandle = [NSFileHandle fileHandleForWritingAtPath:saveFile];
	//create a mutable array which will hold the data to be writen
	NSMutableSet * writeData = [[NSMutableData alloc] init];
	//set up that bad boy
	CoolScore = 10;
	[writeData appendBytes:(void*)&CoolScore length:sizeof(NSInteger)];
	//write
	[filehandle writeData:writeData];
	
	printf("Cool Score is: %i \n", CoolScore);

	//release array
	[writeData release];
	//release handle
	[filehandle release];
	*/
}

/*
 Code wasnt working, will sort out one day...
 */
-(void) loadData
{
	/*
	NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
	NSString *documentsDirectory =[paths objectAtIndex:0];
	//sort out the file name to get the file we need
	
	NSString *loadfilename = @"lulz";
	NSString *loadFile = [documentsDirectory stringByAppendingPathComponent:loadfilename];
	
	//kick ass file operations
	//use the file manager object
	NSFileManager * fileManager = [NSFileManager defaultManager];
	
	//check to see if file exists
	if ([fileManager fileExistsAtPath:loadFile])
	{
		//remove the file it
		//[fileManager removeItemAtPath:filename error:nil];
	}

	
	//index to location in data file
	NSInteger index = 0;
	//load the contents of the file
	NSData *myData = [[NSData alloc] initWithContentsOfFile:loadfilename];
	
	//set up variables to hold data
	
	NSInteger tempTest;
	NSFileHandle * filehandle = [NSFileHandle fileHandleForReadingAtPath:loadFile];
	//pass in the name of the variable to set
	//index size of data type
	[myData getBytes:(void*)&tempTest range:NSMakeRange(0, sizeof(NSInteger))];
	[filehandle readData:myData];
	index +=sizeof(NSInteger);
	
	printf("tempTest is: %i \n", tempTest);
	//clean up
	//release array
	[myData release];
	//release handle
	[filehandle release];
	 */
}


- (void)dealloc 
{
	[musicPlayer cleanAVAudio];
	[musicPlayer release];	
	[menu release];	
	[gameOverViewController release];
	[hiScoreViewController release];	
    [viewController release];
    [window release];
    [super dealloc];
}


@end
