//
//  audioAV.m
//  SnakeMenu
//
//  Created by HANSON, PAUL  on 11/05/2010.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "audioAV.h"


@implementation audioAV

@synthesize AVPlayer;

/*
Creates the audio player and loads the specified sound
Parameter - NSString*
*/
-(void) initAVAudio:(NSString*)file
{
	//set the file path of the audio (location, name, type)
	NSString *AVfilePath = [[NSBundle mainBundle] pathForResource:file ofType:@"mp3"];
	//create the file URL
	NSURL *AVURL = [[NSURL alloc] initFileURLWithPath: AVfilePath];
	
	//create the AVAudioPLayer
	AVPlayer =[[AVAudioPlayer alloc] initWithContentsOfURL: AVURL error: nil];
	
	//prepare to play by preloading the buffers
	[AVPlayer prepareToPlay];
	
	AVPlayer.numberOfLoops = -1;
	
	printf("AV Loaded\n");
}

/*
Plays the audio
*/
-(void) playAVAudio
{
	[self.AVPlayer play];
	printf("AV Playing\n");
}

/*
Stops the audio and undoes the setup
*/
-(void) stopAVAudio
{
	[self.AVPlayer stop];
}

/*
Pauses the audio
*/
-(void) pauseAVAudio
{
	if(self.AVPlayer.playing)
	{
		[self.AVPlayer pause];
		printf("AV Paused\n");
	}
}

/*
Sets the audio volume
*/
-(void) setAVVolume:(float)level
{
	[self.AVPlayer setVolume: level];
}

/*
Clean up the class
*/
-(void) cleanAVAudio
{
	[AVPlayer release];
}

@end
