/*
 *  gameLogic.h
 *  SnakeMenu
 *
 *  Created by HANSON, PAUL  on 11/05/2010.
 *  Copyright 2010 __MyCompanyName__. All rights reserved.
 *
 */

#ifndef _GAME_LOGIC_
#define _GAME_LOGIC_

#define TILEX 16
#define TILEY 16

#define SCORE_AWARD 100

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "snake.h"
#include "map.h"
#include "item.h"


//construct
void createItem(item *i, map *m);
int collisionDetection(snake *s, map *m);
void runLogic();
void render(CGContextRef ref);
void renderMap(map *m, CGRect *r, CGContextRef CG);
int move(int value);
void reset();
void loadImage();
void cleanUp();

//global variables
unsigned int playerScore = 0;
unsigned int highScore = 0;
unsigned int playerStartLength = 5;
unsigned int playerStartSpeed = 20;
unsigned int numberOfItemsOnScreen = 10;

//images globals
CGImageRef strawberryImage;
CGImageRef appleImage;
CGImageRef snakeImage;
CGImageRef starImage;
CGImageRef emptyImage;

#endif


/*
#pragma once

//Include headers
#include <windows.h>
#include <d3d9.h>
#include <d3dx9.h>

#include <string>
#include <sstream>


class GameLogic
{
	public:
		GameLogic(void);
		~GameLogic(void);

		//init the game
		bool init(HINSTANCE, hInstance, LPSTR cmdOptions);
		//Windows pump
		LRESULT CALLBACK wndProc(HWND hWnd, UINT, uMsg, WPARAM wParam, LPARAM lParam);
		//game loop
		bool run();

};
/*
//CGameApplication class
class CGameApplication
{
public:
	CGameApplication(void);
	virtual ~CGameApplication(void);

	//Initialise the game
	bool init(HINSTANCE hInstance,LPSTR cmdOptions);
	//Windows Message pump
	LRESULT CALLBACK wndProc( HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam );
	//game loop
	bool run();
private:
	//load string table
	void loadStringTable(char * filename);
	//create graphics
	bool createD3DDevice(int width,int height,bool bFullscreen);
	//create windows
	bool createWindow(TCHAR * windowTitle,int width,int height,bool bFullscreen);
	//init game
	virtual bool initGame();
	//init input
	bool initInput();
	//update game
	virtual void update(float fElapsedTime);
	//render current frame
	virtual void render();
	//init map
	bool initMap();
protected:
	//Handle to window
	HWND m_hWnd;
	//Instance of Application
	HINSTANCE m_hInstance;
	//Window width and height
	int m_iWindowWidth;
	int m_iWindowHeight;
	//bool to tell if the game is running
	bool m_bIsRunning;
	//Direct3D object
	IDirect3D9 *m_pD3D9;
	//Direct3D Device
	IDirect3DDevice9 *m_pD3DDevice9;
	//joypads
	//start time
	DWORD m_dwStartTime;
	//last time that a frame was updated
	DWORD m_dwCurrentTime;
	//Text to display stats
	CGUIText *m_pFrameStatText;
	//
	float m_fTotalTime;
	float m_fLastTime;
	int m_iFPS;
	wstringstream m_FPSStringStream;
	//Matrices
	//World
	D3DXMATRIX m_matWorld;
	//Projection
	D3DXMATRIX m_matProjection;
	//View
	D3DXMATRIX m_matView;

	//Scale
	D3DXMATRIX m_matScale;
	//Rotation
	D3DXMATRIX m_matRotation;
	float m_fRotate;
	//Translation
	D3DXMATRIX m_matTranslation;

	//window position
	int m_xPos;
	int m_yPos;
	int m_xSize;
	int m_ySize;

	//active window
	bool m_bFocus;

	//map
	Map *m_pMap;

	//Map Rect
	RECT rectPosition;
	RECT tempRectPosition;
	BYTE byTile;
	
	//tile range
	int m_xStart;
	int m_yStart;
	int m_xEnd;
	int m_yEnd;
	int x, y;

	//input
	CDirectInputFactory *m_pInputFactory;
	IKeyboard *m_pKeyboard;
};

*/

/*
    *  Create a window.
    * Initialize DirectX:
          o Set up DirectDraw.
          o Create three surfaces: primary, back buffer, and tileset.
          o Create a clipper and attach it to the back buffer. 
    * Load tileset and map.
    * Main loop:
          o Handle the Windows message queue.
          o Exit loop if WM_QUIT message found.
          o Check for user input.
          o Render the map to the back buffer:
                + Find the horizontal and vertical ranges of tiles that need to be drawn.
                + Update tile pointers to account for animations.
                + Blit the first layer without color keying, so it overwrites the previous frame completely.
                + Blit the second layer with color keying. 
          o Flip the frame to the primary surface.
          o Lock to a constant frame rate. 
    * Shut down DirectX.
    * Return to Windows. 

			// set original destination RECT for first
			// tile -- aligned with the upper-left
			// corner of the screen
			RECT rcDest = {0, 0, 32, 32};

			// find default tile range -- divide camera
			// coordinates by 32 and use the default of
			// 21 tiles across and 16 tiles down
			int xStart = mapdata.xCamera >> 5;
			int yStart = mapdata.yCamera >> 5;
			int xEnd = xStart + 20;
			int yEnd = yStart + 15;
			int x, y;

			// now check if the camera coordinates are divisible by 32
			x = mapdata.xCamera & 0x0000001F;
			y = mapdata.yCamera & 0x0000001F;

			if (!x)
			{
			  // if xCamera is divisible by 32, use only 20 tiles across
			  xEnd--;
			}
			else
			{
			  // otherwise move destination RECT to the left to clip
			  // the first column of tiles
			  rcDest.left-=x;
			  rcDest.right-=x;
			}

			if (!y)
			{
			  // if yCamera is divisible by 32, use only 15 tiles down
			  yEnd--;
			}
			else
			{
			  // otherwise move destination RECT up to clip the first row of tiles
			  rcDest.top-=y;
			  rcDest.bottom-=y;
			}

			// finally make sure we're not exceeding map limits
			if (xEnd > mapdata.xMax)
			  xEnd = mapdata.xMax;
			if (yEnd > mapdata.yMax)
			  yEnd = mapdata.yMax;

*/